<p>Savladavanjem prethodnih definicija konačno smo spremni za otkrivanje temelja na kojem počiva zaštitno kodiranje. Trebamo još samo jednu novu definiciju.</p>

<p><em>Minimalna distanca koda</em> (ili kraće, <em>distanca koda</em>; podrazumijevamo da se radi o Hammingovoj distanci) je distanca između dvije najbliže riječi promatranog koda. Pogledajmo to ponovno na primjeru koda koji dvobitni podatak štiti na način da ga još jednom ponovi u zaštićenoj kodnoj riječi. Riječi tog koda su bile: {0000, 0101, 1010, 1111}. Kolika je minimalna distanca tog koda? Trebamo izračunati distancu između prve riječ i preostale 3, druge i preostale 3, treće i preostale 3 te četvrte i preostale 3.</p>

<style>
TABLE.priv-t-style {border-style: none; margin-left: auto; margin-right: auto; border-spacing: 0; border-collapse: collapse;}
TABLE.priv-t-style td { text-align: center; padding: 5px;}
TABLE.priv-t-style td.ptlt {border-left: 1px solid black;border-top: 1px solid black;}
TABLE.priv-t-style td.ptlm {border-left: 1px solid black;}
TABLE.priv-t-style td.ptlb {border-left: 1px solid black;border-bottom: 1px solid black;}
TABLE.priv-t-style td.pttm {border-top: 1px solid black;}
TABLE.priv-t-style td.ptrt {border-right: 1px solid black;border-top: 1px solid black;}
TABLE.priv-t-style td.ptbm {border-bottom: 1px solid black;}
TABLE.priv-t-style td.ptrb {border-right: 1px solid black;border-bottom: 1px solid black;}
TABLE.priv-t-style td.ptrm {border-right: 1px solid black;}
</style>
<table class="priv-t-style">
<tr><td>&nbsp;</td><td>0000</td><td>0101</td><td>1010</td><td>1111</td></tr>
<tr><td>0000</td><td class="ptlt">&#8902;</td><td class="pttm">2</td><td class="pttm">2</td><td class="ptrt">4</td></tr>
<tr><td>0101</td><td class="ptlm">2</td><td>&#8902;</td><td>4</td><td class="ptrm">2</td></tr>
<tr><td>1010</td><td class="ptlm">2</td><td>4</td><td>&#8902;</td><td class="ptrm">2</td></tr>
<tr><td>1111</td><td class="ptlb">4</td><td class="ptbm">2</td><td class="ptbm">2</td><td class="ptrb">&#8902;</td></tr>
</table>

<p>Broj izračuna možemo smanjiti ako uočimo da distanca zadovoljava svojstvo simetričnosti: \(d_H(x,y) = d_H(y,x)\): pogledajte prethodnu tablicu i uočite da je simetrična oko glavne dijagonale. Stoga je dovoljno izračunati distance <i>i</i>-te riječi samo onih koje su nakon nje. Distanca između riječi i same sebe je uvijek nula, no taj nas slučaj ne zanima: u tablici smo te situacije označili zvjezdicom.</p>

<p>Različiti kodovi ove će distance imati različite. Neki će kodovi između svih parova kodnih riječi imati jednaku distancu; neki će kodovi imati situaciju koja je nastupila i u našem slučaju - distance će varirati od para do para.</p>

<p>Minimalna distanca koda je minimum od svih izračunatih distanci između (različitih) kodnih riječi. U našem slučaju, to je minimum između 2 i 4 što je 2. Zašto nam je minimalna distanca koda važan pojam?</p>

<div class="mlImportant">
<p>Ako je minimalna distanca koda jednaka <i>d</i>, tada znamo da u kodu ne postoji niti jedan par kodnih riječi koji je na manjoj udaljenosti od <i>d</i>: sve kodne riječi su barem na tolikoj udaljenosti (pogledajte gornju tablicu: sve kodne riječi su barem na udaljenosti 2, a neke su i na većoj). Ako u sustavu djeluju pogreške koje mijenjaju bitove poslane kodne riječi, sada pouzdano znamo da pogreške moraju promijeniti minimalno <i>d</i> bitova (čime će poslanu kodnu riječ pretvoriti onu drugu kodnu riječ koja je na toj distanci) da bi se dogodio slučaj da prijemnik ne može otkriti da su djelovale smetnje koje su mijenjale bitove.</p>
</div>

<p>Primjerice, ako u našem slučaju predajnik pošalje 0000 i dogode se dvije pogreške - na prvom i trećem bitu, prijemnik će primiti 1010 i zaključiti da nema pogrešaka, da mu je poslan podatak 10 i da je shodno tome stigla zaštićena kodna riječ 1010. Mi kao vanjski promatrač vidimo da to nije točno no prijemnik to ne može zaključiti.</p>

<p>Važna posljedica ovoga je sljedeća. <span class="mlUnderline">Zaštitni kod čija je minimalna distanca <i>d</i> može otkriti pojavu najviše <i>d</i>-1 pogreške</span>, što se lijepo može ilustrirati grafički.</p>

<figure class="mlFigure">
<img src="@#file#(greske-hr.svg)" alt="Djelovanje pogrešaka i distanca koda." border="0">
<figcaption>Razmatramo dvije kodne riječi <i>x</i> i <i>y</i> koje su na distanci <i>d</i>=6. Dogodi li se od jedne do 5 pogrešaka, i dalje nećemo doći do druge kodne riječi već ćemo ostati u skupu nelegalnih kodnih riječi koji postoji zahvaljujući redundantnim bitovima.</figcaption>
</figure>

<p>Slika prikazuje dvije kodne riječi (<i>x</i> i <i>y</i>; mali zeleni kružići lijevo i desno) koje se nalaze na distanci 6. Pretpostavimo da je to ujedno i minimalna distanca koda kojemu pripadaju te dvije kodne riječi. Pošaljemo li kodnu riječ <i>x</i>, pogreške će tu kodnu riječ pretvarati u kodnu riječ koja je sve sličnija kodnoj riječi <i>y</i>, i na slici se krećemo od zelenog kružića lijevo po crvenim kružićima udesno. Ti kružići predstavljaju nelegalne riječi koje su na sve većoj i većoj distanci od kodne riječi <i>x</i>. Međutim, ako se dogodi čak 6 pogrešaka, kolika je distanca između <i>x</i> i <i>y</i>, poslana kodna riječ bit će primljena kao <i>y</i> i prijemnik neće moći utvrditi da je došlo do pogreške. Dogodi li se manje od 6 pogrešaka, što je minimalna distanca koda iz ovog primjera, prijemnik će pouzdano moći utvrditi da je došlo do pogreške.</p>

<p>Pitanje koje se odmah nameće je sljedeće: ako prijemnik zna da nešto ne valja (primio je "crvenu" riječ), odnosno da je broj pogrešaka koje su se dogodile manji od 6, može li znati što je točno bilo poslano? Odgovor je: ne može. Ovo ćemo ilustrirati na jednostavnom primjeru prikazanom na slici u nastavku.</p>

<figure class="mlFigure">
<img src="@#file#(greske2-hr.svg)" alt="Nemogućnost određivanja izvorne kodne riječi." border="0">
<figcaption>Primili smo kodnu riječ koja odgovara drugom s lijeva crvenom kružiću. Što je bilo poslano?</figcaption>
</figure>

<p>Pogledajte pažljivo sliku. Pretpostavimo da smo primili kodnu riječ koja odgovara drugom s lijeva crvenom kružiću. Možemo li zaključiti što je bilo izvorno poslano? Ako je jedino što znamo činjenica da se dogodilo pet pogrešaka ili manje, tada ne možemo zaključiti što je bilo poslano. Naime, ako je bio poslan <i>x</i>, uz dvije pogreške pri prijenosu primili bismo upravo razmatranu riječ. Ako je pak bio poslan <i>y</i>, uz četiri pogreške pri prijenosu također bismo primili razmatranu riječ. Kako ne znamo koji je slučaj od ta dva nastupio, ne možemo znati niti što je izvorno bilo poslano.
</p>

<p>Iako će se možda na prvu činiti da je u suprotnosti s prethodnim primjerom, zaštitne kodove možemo koristiti i za ispravljanje pogrešaka. Međutim, važno je razumjeti u kojim uvjetima, odnosno uz koje pretpostavke.</p>

<p><em>Pretpostavka 1.</em> Primimo li nelegalnu kodnu riječ, definirat ćemo da se ispravljanje pogrešaka radi tako da se u kodu pronađe valjana kodna riječ koja je najbliža (na najmanjoj distanci) primljenoj riječi. Ta će kodna riječ, ako je jedinstvena, biti uzeta kao rezultat postupka ispravljanja pogrešaka. U suprotnom postupak ne uspjeva.</p>

<p>Ilustrirajmo to na primjeru. Neka imamo kod {00000000,11110000,11111111}. Primimo li riječ 11110000, to je OK. Primimo li riječ 10110001, pokrećemo postupak ispravljanja. Računamo distance do svih legalnih kodnih riječi.
$$
d_H(10110001,00000000) = 4 \\
d_H(10110001,11110000) = 2 \\
d_H(10110001,11111111) = 4
$$
Postupak ispravljanja vratit će kodnu riječ 11110000 kao ispravak jer je ona bila najbliža primljenoj kodnoj riječi.
</p>

<p>Pitanje koje se sada postavlja je sljedeće: uz koje pretpostavke će ovaj postupak garantirano vratiti kodnu riječ koja je stvarno bila poslana? Da bismo odgovorili na to pitanje, opet se moramo vratiti na minimalnu distancu koda. Pretpostavimo da je minimalna distanca koda neparan broj. Primjerice, 7. To znači da su sve kodne riječi koda barem na udaljenosti 7 (i sigurno postoji barem jedan par koji je točno na toj udaljenosti). Situacija je prikazana na slici u nastavku. Pretpostavimo također da je predajnik poslao <i>x</i>.</p>

<table class="mlTableCC">
<tr>
 <td>
  <p><img src="@#file#(greske3a-hr.svg)" alt="Jedna pogreška" border="0"></p>
  <p>a) Poslan <i>x</i>; dogodila se jednostruka pogreška. Algoritam ispravljanja će vratiti <i>x</i>.</p>
 </td>
 <td>
  <p><img src="@#file#(greske3b-hr.svg)" alt="Dvije pogreške" border="0"></p>
  <p>b) Poslan <i>x</i>; dogodila se dvostruka pogreška. Algoritam ispravljanja će vratiti <i>x</i>.</p>
 </td>
</tr>
<tr>
 <td>
  <p><img src="@#file#(greske3c-hr.svg)" alt="Tri pogreške" border="0"></p>
  <p>c) Poslan <i>x</i>; dogodila se trostruka pogreška. Algoritam ispravljanja će vratiti <i>x</i>.</p>
 </td>
 <td>
  <p><img src="@#file#(greske3d-hr.svg)" alt="Četiri pogreške" border="0"></p>
  <p>d) Poslan <i>x</i>; dogodila se četverostruka pogreška. Algoritam ispravljanja će vratiti <i>y</i> što je pogrešno.</p>
 </td>
</tr>
</table>

<p>Prikazani postupak ispravljanja je uspješan sve dok je broj nelegalnih kodnih riječi između stvarno poslane kodne riječi i primljene riječi manji od broja nelegalnih kodnih riječi između primljene riječi i najbližeg legalnog para stvarno poslane kodne riječi. Kako je u našem primjeru distanca koda 7, između dvije legalne riječi nalazi se 6 nelegalnih. Ako pod utjecajem pogrešaka ne pređemo više od njih pola, postupak ispravljanja će nas vratiti natrag do stvarno poslane kodne riječi. Problem nastaje kada pređemo pola puta (prikazano kao slučaj d) jer nas tada postupak ispravljanja šalje u kodnu riječ koja nije ona koja je bila poslana.</p>

<p>Na temelju ovog razmatranja mogli bismo zaključiti ovako: ako je minimalna distanca koda <i>d</i>, između svakog para legalnih kodnih riječi ima barem <i>d</i>-1 nelegalna kodna riječ, pa tako dugo dok broj pogrešaka koje su se dogodile nije veći od polovice toga, odnosno od (<i>d</i>-1)/2, postupak ispravljanja će raditi korektno. Mali problem tu će nam napraviti parne minimalne distance, pa idemo pogledati i jedan takav primjer.</p>

<p>Neka je minimalna distanca koda jednaka 6. Kako tada izgledaju sličice?</p>

<table class="mlTableCC">
<tr>
 <td>
  <p><img src="@#file#(greske4a-hr.svg)" alt="Jedna pogreška" border="0"></p>
  <p>a) Poslan <i>x</i>; dogodila se jednostruka pogreška. Algoritam ispravljanja će vratiti <i>x</i>.</p>
 </td>
 <td>
  <p><img src="@#file#(greske4b-hr.svg)" alt="Dvije pogreške" border="0"></p>
  <p>b) Poslan <i>x</i>; dogodila se dvostruka pogreška. Algoritam ispravljanja će vratiti <i>x</i>.</p>
 </td>
</tr>
<tr>
 <td>
  <p><img src="@#file#(greske4c-hr.svg)" alt="Tri pogreške" border="0"></p>
  <p>c) Poslan <i>x</i>; dogodila se trostruka pogreška. Algoritam ispravljanja više ne radi: dva su kandidata kao korekcija.</p>
 </td>
 <td>
  &nbsp;
 </td>
</tr>
</table>

<p>Kao što se vidi s prethodnih slika, ako je distanca parna, tada je broj pogrešaka koji se može ispraviti manji od polovice broja nelegalnih kodnih riječi između promatrane dvije legalne. U ovom slučaju, vidimo da ispravljanje radi za do dvije pogreške, dok je (<i>d</i>-1)/2 = (<i>6</i>-1)/2 = 5/2 = 2,5.</p>

<p>Opisana dva slučaja (parna i neparna minimalna distanca) mogu se spojiti u jedan izraz uporabom operatora odsijecanja decimalnog dijela (ili zaokruživanja prema nižem cijelom broju). Simbol koji se koristi je \(\lfloor x \rfloor\). Evo par primjera.
\(
  \lfloor 2.5 \rfloor = 2, 
  \lfloor 3.0 \rfloor = 3, 
  \lfloor 3.2 \rfloor = 3,
  \lfloor 3.8 \rfloor = 3, 
  \lfloor 4.1 \rfloor = 4
\).
</p>

<p>Oslanjajući se na taj operator, sada možemo izreći sljedeće važno svojstvo zaštitnog koda. <span class="mlUnderline">Zaštitni kod čija je minimalna distanca <i>d</i> može ispraviti do \( \lfloor \frac{d-1}{2} \rfloor \) pogrešaka</span>.
</p>

<p>Sumirajmo najvažnije.</p>

<div class="mlImportant">
Neka je minimalna distanca zaštitnog koda jednaka <i>d</i>. Takav kod ima sljedeća svojstva.
<ul>
<li>Broj pogrešaka koje može otkriti (u smislu: "nešto ne valja") je \( d-1 \).</li>
<li>Broj pogrešaka koje može ispraviti je \( \lfloor \frac{d-1}{2} \rfloor \).</li>
</ul>
Isto možemo izreći na drugi način.
<ul>
<li>Ako zaštitni kod mora moći otkrivati do <i>t</i> pogrešaka, njegova minimalna distanca mora biti barem \( t+1 \).</li>
<li>Ako zaštitni kod mora moći ispravljati do <i>t</i> pogrešaka, njegova minimalna distanca mora biti barem \( 2 \cdot t + 1 \).</li>
</ul>
</div>

<p>Evo u nastavku jednog pitanja za Vas.</p>
